#ifndef FGGL_GFX_GLFW_COMPAT_H
#define FGGL_GFX_GLFW_COMPAT_H
/**
 * Window management Calls.
 *
 * This shouldn't be exposed to the demo app, but the ECS we're using isn't smart enouph to allow us to
 * abstract this yet. It's next thing on the list, but this branch is about cleaning up OpenGL not about
 * extending our ECS.
 *
 * Should be removed when the engine has suitable abstractions in place.
 */

#include <memory>

#include <utility>
#include <fggl/gfx/window.hpp>
#include <fggl/ecs3/ecs.hpp>

namespace fggl::gfx {

	//
	// fake module support - allows us to still RAII
	//
	struct ecsGlfwModule : ecs3::Module {
		GlfwContext context;

		inline explicit
		ecsGlfwModule(std::shared_ptr<fggl::input::Input> inputs) : context(std::move(inputs)) {
		}

		inline
		std::unique_ptr<GlfwWindow> createWindow(const std::string &title) {
			auto window = std::make_unique<GlfwWindow>();
			window->title(title);
			return window;
		}

		void onUpdate() override {
			context.pollEvents();
		}

		[[nodiscard]]
		std::string name() const override {
			return "gfx::glfw";
		}

	};

}

#endif
